// Define member functions of class DateType.
// This is file DateType.cpp.

#include "DateType.h" // gain access to specification of class
#include <iostream>
#include <ctime>
using namespace std;

DateType::DateType()
// The first constructor method
// Post: year is initialized to 2000.
//       month is initialized to 1.
//       day is initialized to 1.
{
  year = 2000;
  month = 1;
  day = 1;
}


DateType::DateType(int newMonth, int newDay, int newYear)
// The second constructor method
// Post: year is initialized to newYear.
//       month is initialized to newMonth.
//       day is initialized to newDay.
{

	if (IsValidDate (newMonth, newDay, newYear))
	{

		year = newYear;
		month = newMonth;
		day = newDay;
	}
	else
	{
		cout << "ERROR: This is not a valid date.  Date will be set to default." << endl;
		year = 2000;
		month = 1;
		day = 1;
	}
}


//Added method to check the input date to see if it is valid.
bool DateType::IsValidDate(int Month, int Day, int Year)
{
	if (Year==0)
		return false;

	else if (Month==1 || Month==3 || Month==5 || Month==7 || Month==8 || Month==10 || Month==12)
	{
		if (Day >=1 && Day <=31)
			return true;
		else
			return false;
	}

	else if (Month==4 || Month==6 || Month==9 || Month==11)
	{
		if (Day>=1 && Day<=30)
			return true;
		else
			return false;
	}

	else if (Month==2)
	{
		if ((Year%400==0) || (Year%4==0 && Year%100!=0))
		{
			if (Day>=1 && Day<=29)
			return true;
			else
				return false;
		}
		else
		{
			if (Day>=1 && Day<=28)
			return true;
			else
				return false;
		}
	}

	else
		return false;
}
//End added method.




bool DateType::SetDate(int newMonth, int newDay, int newYear)
// Post: return false if the date is invalid
//		 otherwise return true, and
//		 year is set to newYear.
//       month is set to newMonth.
//       day is set to newDay.
{

	if (IsValidDate (newMonth, newDay, newYear))
	{

		year = newYear;
		month = newMonth;
		day = newDay;

		return true;
	}
	else
	{
		cout << "ERROR: This is not a valid date.  Date will be set to default." << endl;
		return false;
	}
}

int DateType::MonthIs()
// Accessor function for data member month.
{
  return month;
}

int DateType::YearIs()
// Accessor function for data member year.
{
  return year;
}


int DateType::DayIs()
// Accessor function for data member day.
{
    return day;
}


void DateType::ReadDate()
{
	cout << endl 
		 << "Read in the information of a date: " ;
		 
	cout << endl << "The month is: "; 
	cin >> month;
	cout << "The day is: "; 
	cin >> day;
	cout << "The year is: "; 
	cin >> year;

	while (! IsValidDate(month, day, year) )
	{

		cout << endl 
		<< "Not a date!, Try it again: " ;
			 
		cout << endl << "The month is: "; 
		cin >> month;
		cout << "The day is: "; 
		cin >> day;
		cout << "The year is: "; 
		cin >> year;

	}

}



void DateType::PrintDate()
{
	//Implement your code here
	if (IsValidDate (month, day, year))
		cout << month << "/" << day << "/" << year << endl;
	else
		cout << "ERROR: This is not a valid date." << endl;
}


int DateType::ComparedTo(DateType aDate)
// Pre: Self and aDate have been initialized.
// Post: return
//  LESS, if self comes before aDate.
//  EQUAL, if self is the same as aDate.
//  GREATER, if self comes after aDate.
{
	//Replace the return statement with your own code here
	if (year < aDate.year)
		return -1;

	else if (year > aDate.year)
		return 1;

	else if (year == aDate.year)
	{
		if (month < aDate.month)
			return -1;
		else if (month > aDate.month)
			return 1;
		else if (month == aDate.month)
		{
			if (day < aDate.day)
				return -1;
			else if (day > aDate.day)
				return 1;
			else if (day == aDate.day)
				return 0;
		}
	}

}

int DateType::ComparedCentury(DateType aDate)
// Pre: Self and aDate have been initialized.
// Post: return
//	LESS, if the object itSelf comes before the century of aDate.
//	EQUAL, if the object itSelf is in the same century as aDate.
//	GREATER, if the object itSelf comes after the century of aDate.
{
	//Replace the return statement with your own code here
	if (year == aDate.year)
		return 0;

	if (year/100 < aDate.year/100)
		return -1;
	if (year/100 == aDate.year/100)
		return 0;
	if (year/100 > aDate.year/100)
		return 1;
}

//Advance the date by "NumDays" days.
void DateType::AdvanceDays(int NumDays)
{
	int index=0;
	
	if (NumDays > 0)
	{
		for (index=0; index<NumDays; index++)
		{
			if(month==1 || month==3 || month==5 || month==7 || month==8 || month==10 || month==12)
			{
				if (day>=1 && day <=30)
				{
					day++; 
				}
				else if (day==31)
				{
					if (month==12)
					{
						day=1; month=1; year++; 
					}
					else
					{
						day=1; month++;
					}
				}
			}

			else if (month==4 || month==6 || month==9 || month==11)
			{
				if (day>=1 && day<=29)
				{
					day++; 
				}
				else if (day==30)
				{
					day=1; month++; 
				}
			}

			else if (month==2)
			{
				if ((year%400==0) || (year%4==0 && year%100!=0))
				{
					if (day>=1 && day<=28)
					{
						day++; 
					}
					else if (day==29)
					{
						day=1; month++; 
					}
				}
				else
				{
					if (day>=1 && day<=27)
					{
						day++; 
					}
					else if (day==28)
					{
						day=1; month++; 
					}
				}
			}
		}
	}
	else
		cout << "ERROR: This is not a valid number of days." << endl;
}


//Set back the date by "NumDays" days.
void DateType::BackDays(int NumDays)
{
	int index=0;

	
	if (NumDays > 0)
	{
		for (index=0; index<NumDays; index++)
		{
			if(month==1 || month==3 || month==5 || month==7 || month==8 || month==10 || month==12)
			{
				if (day>=2 && day <=31)
				{
					day--; 
				}
				else if (day==1)
				{
					if (month==3)
					{
						if ((year%400==0) || (year%4==0 && year%100!=0))
						{
							month=2; day=29; 
						}
						else
						{
							month=2; day=28; 
						}
					}
					else if (month==1)
					{
						month=12; day=31; year--; 
					}
					else if (month==8)
					{
						month--; day=31; 
					}
					else
					{
						month--; day=30; 
					}
				}
			}

			else if (month==2 || month==4 || month==6 || month==9 || month==11)
			{
				if (day>=2 && day<=30)
				{
					day--; 
				}
				else if (day==1)
				{
					month--; day=31; 
				}
			}
		}
	}

	else
		cout << "ERROR: This is not a valid number of days." << endl;
}



//************************************************************
// New implementations
//************************************************************

//Set the date to a valid random date
void DateType::SetRandomDate()
{ 
	//sets year first
	year = rand();
	
	//sets month modulus 12, plus one
	//this guarantees a valid month
	month = rand()%12+1;

	//sets the day according to the month
	//so that the day is not greater than
	//the number of days in that month
	if(month==1 || month==3 || month==5 || month==7 || month==8 || month==10 || month==12)
	   day = rand()%31+1;

	else if (month==4 || month==6 || month==9 || month==11)
		day = rand()%30+1;

	else if (month==2)
	{
		if ((year%400==0) || (year%4==0 && year%100!=0))
			day = rand()%29+1;
		else
			day = rand()%28+1;
	}
}


//Define the relationl operator >
bool DateType::operator> (const DateType & aDate)
{

   //Remove everything in this block and write your own code
	if (year > aDate.year)
		return true;
	else	if (year < aDate.year)
		return false;


	if (month > aDate.month)
		return true;
	else if (month < aDate.month)
		return false;

	if (day > aDate.day)
		return true;

	return false;
}

//Define the relationl operator >=
bool DateType::operator>= (const DateType & aDate)
{

   //Remove everything in this block and write your own code
	if (year > aDate.year)
		return true;
	else	if (year < aDate.year)
		return false;


	if (month > aDate.month)
		return true;
	else if (month < aDate.month)
		return false;

	if (day >= aDate.day)
		return true;

	return false;
}

//Define the relationl operator <
bool DateType::operator< (const DateType & aDate)
{
   //Remove everything in this block and write your own code
	if (year < aDate.year)
		return true;
	else	if (year > aDate.year)
		return false;


	if (month < aDate.month)
		return true;
	else if (month > aDate.month)
		return false;

	if (day < aDate.day)
		return true;

	return false;

}

//Define the relationl operator <=
bool DateType::operator<= (const DateType & aDate)
{
   //Remove everything in this block and write your own code
	if (year < aDate.year)
		return true;
	else	if (year > aDate.year)
		return false;


	if (month < aDate.month)
		return true;
	else if (month > aDate.month)
		return false;

	if (day <= aDate.day)
		return true;

	return false;

}

//Define the relationl operator ==
bool DateType::operator== (const DateType & aDate)
{

   //Remove everything in this block and write your own code


	if (	this->month == aDate.month &&
		this->day == aDate.day &&
		this->year == aDate.year
	)
		return true;

	return false;

}

//Define the relationl operator !=
bool DateType::operator!= (const DateType & aDate)
{

   //Remove everything in this block and write your own code

	if (	this->month == aDate.month &&
		this->day == aDate.day &&
		this->year == aDate.year
	)
		return false;
	
	return true;

}


ostream & operator<< (ostream & output, const DateType & aDate)
{
	//If the ostream object output is simply cout, use slashes as delimiters between month, day, year;
	//otherwise, use spaces as delimiters between or month, day, year;

	if (output == cout)
		cout << aDate.month << '/' << aDate.day << '/' << aDate.year << endl;
	else
		cout << aDate.month << ' ' << aDate.day << ' ' << aDate.year << endl;

	return output;

}

istream & operator>> (istream & input, DateType & aDate)
{

	int m,d,y; //Temporary variables for month, day, year

	//If the istream object input is simply cin, disply promoting messages on screen through cout.
	//otherwise, silently read the information from input.

	if (input == cin)
		cout << endl 
			 << "Read in the information of a date: " << endl
			 << "The month is: "; 
	input >> m;

	if (input == cin)
		cout << endl << "The day is: "; 
	input >> d;

	if (input == cin)
		cout << endl << "The year is: "; 
	input >> y;

	if (! aDate.IsValidDate(m,d,y) )
	{

		cout << endl 
		<< "Error, Not a valid date! Use the default date 01/01/2000" ;
			 
		m =1; d=1; y = 2001;
	}

	aDate.month = m;
	aDate.day = d;
	aDate.year = y;

	return input;

}

