// File: main.cpp

#include <iostream>
#include <ctime>
#include <cmath>
#include "DateType.h"
#include "Tree.h"
using namespace std;

int main()
{
	srand( (unsigned int)time( NULL ) );

	Tree myList;

	int heightArray[1000];


  //This main function provides a menu that allows
  //	the user to repeatedly do any of the following tasks:
  // (1) display the current contents of mylist
  // (2) insert a new date into mylist
  // (3) remove a date from mylist
  // (4) search to determine whether a date given by the user is currently in mylist
  // (5) quit the program



	char keyPressed;	// This var stores which menu selection the user picks.

	DateType myDate;			//For storing an integer

	bool inMenu = true;	// while the user is using the program this var is set to true and the menu keeps looping.
						// when the user wants to quit, it is set to false and the loop ends.

	int num;

	Tree myTree;
	double averageHeight;
	int total=0;
	double sum=0;
	double deviation;
	double range1=0;
	double range2=0;
	double percentage1;
	double percentage2;

	int treeSize;

	while ( inMenu )
	{
		cout << endl << endl;
		cout  <<"** MENU **" << endl;
 		cout << "****************************************************" << endl;
		cout << endl;

		cout << "D. [DISPLAY] Display the dates in the whole list" << endl;
		cout << "I. [INSERT]  Insert a new date into the list" << endl;
		cout << "R. [REMOVE]  Remove a date from the list" << endl;
		cout << "S. [SEARCH]  Search for a date " << endl;
		cout << "T. [TIME TEST]	Insert n random dates and then delete n random dates " << endl;
		cout << "H. [HEIGHT TEST] Calculate and determine the height of the binary search tree" << endl;
		cout << "C. [CLEAR] Clear the search tree to make it empty" << endl;
		cout << "E. [EXPERIMENTS] Run loops to do experiments with the heights of binary search trees" << endl;
		cout << "Q. [QUIT]    Quit."<<endl;
		cout << endl;

		cout << "****************************************************" << endl << endl;

		cout<<"Your choice is: ";
		cin >> keyPressed;

		switch(keyPressed) {
		case 'Q': case 'q'://Quit
			cout << "[QUIT]:" << endl;
			inMenu = false;
			break;


		case 'D': case 'd':// Display the list
			cout << "[DISPLAY the list]:" << endl;
			myList.Display();

			break;

		case 'I': case 'i':// Insert a new integer (allowing redundancy)
			cout << "[INSERT a date]:" << endl;
			cout << "Please enter the date to insert:";
			myDate.ReadDate();
			myList.Insert(myDate);

			cout << ">>The date is stored in the list now." << endl;

			break;

		case 'R': case 'r':// Delete an existing line
			cout << "[REMOVE a date from the list]:" << endl;
			cout << "Please enter the date to delete:";
			myDate.ReadDate();
			myList.DeleteItem(myDate);
			cout << ">>The date is NOT stored in the list now." << endl;

			break;

		case 'T': case 't':// Delete an existing line
			cout << "[INSERT n random dates and then delete n random dates]:" << endl;
            cout   << "Two batches of random dates to insert and delete\n";


			num = 0;
			while (num <=0 )
			{

				cout << ">> How many random dates should we generate in each batch?\n";
				cout << ">> Enter a positive integer:";
				cin >> num;
			}

			myList.Clear();
            //build up a random binary search tree of num nodes by doing num insertions

            for(int i = 0; i < num; i++)

            {	
				DateType myDateTypeObject;

                myDateTypeObject.SetRandomDate();

				myList.Insert(myDate);

            }

            //stress the data structure by doing num deletions

            for(int i = 0; i < num; i++)

            {	
				DateType myDateTypeObject;

                myDateTypeObject.SetRandomDate();

                myList.DeleteItem(myDateTypeObject);

            }

			//myList.Clear();

			break;

		case 'S': case 's':// Search for an integer
			cout << "[SEARCH whether a date is in the list]:" << endl;
			cout << "Please enter the date to delete:";
			myDate.ReadDate();
			if ( myList.Search(myDate) == true )
				cout << ">>Yes. This date is currently in the list" << endl;
			else
				cout << ">>No. This date is currently NOT in the list" << endl;

			break;

		case 'H': case 'h':
			cout << "[Calculate the HEIGHT of the binary search tree]" << endl;
			cout << "The height is " << myList.Height();

			break;

		case 'C': case 'c':
			cout << "[CLEAR the list to make it empty]" << endl;
			myList.Clear();
			cout << "The list is now empty" << endl;

			break;

		case 'E': case 'e':
			cout << endl << "***********************************************************" << endl;
			cout << "Slow version" << endl;
			cout << "Experiments: To generate random binary search trees of n nodes" << endl;
			cout << "What is yout choice of n? n=" ;
			cin >> treeSize;

			for (int i=0; i!=200; i++)
			{
				myTree.Clear();
				for (int x=0; x!=treeSize; x++)
				{
					myDate.SetRandomDate();
					myTree.Insert(myDate);
				}
				
				cout << endl << "Random binary search tree of " << treeSize << " nodes: Tree #" << i << endl << "Height = ";
				heightArray[i]=myTree.Height();
				cout << heightArray[i] << endl;
			}

			total=0;

			for (int i=0; i!=20; i++)
			{
				total=total+heightArray[i];
			}

			for (int i=0; i!=20; i++)
				cout << heightArray[i] << endl;

			averageHeight = total/20;
			cout << "Some statistics of 20 trees of 1000 nodes: " << endl;
			cout << "Average Height: " << averageHeight << endl;

			sum=0;
			for (int i=0; i!=20; i++)
			{
				sum=sum+pow(heightArray[i]-averageHeight, 2);
			}

			deviation=sqrt(sum/20);
			cout << "Standard Deviation: " << deviation << endl;

			range1=0;
			range2=0;

			for (int i=0; i!=20; i++)
			{
				if (heightArray[i] >= (averageHeight - 2*deviation) && heightArray[i] <= (averageHeight + 2*deviation))
					range1++;
				if (heightArray[i] >= (averageHeight - 3*deviation) && heightArray[i] <= (averageHeight + 3*deviation))
					range2++;
			}
			
			percentage1=(range1/20)*100;
			percentage2=(range2/20)*100;

			cout << "Percentage within 2 standard deviations of the average height: " << percentage1 << endl;
			cout << "Percentage within 3 standard deviations of the average height: " << percentage2 << endl;
			
			break;




		default:
			cout << "[?? UNKNOWN COMMAND]:" << endl;
			// Unrecognized key, do nothing
			break;
		}

	} // End of while loop.


	//Finished
	return 1;
}


